Index: branches/3073_IA_constraint_splitting_reintegration/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintView.cs
===================================================================
--- branches/3073_IA_constraint_splitting_reintegration/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintView.cs	(revision 17895)
+++ branches/3073_IA_constraint_splitting_reintegration/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintView.cs	(revision 17896)
@@ -2,5 +2,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -29,7 +29,7 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
-  [View("Interval Constraint Detail View")]
+  [View("Shape Constraint View")]
   [Content(typeof(ShapeConstraint), true)]
-  public sealed partial class IntervalConstraintView : ItemView {
+  public sealed partial class ShapeConstraintView : ItemView {
     public new ShapeConstraint Content {
       get => (ShapeConstraint)base.Content;
@@ -37,8 +37,8 @@
     }
 
-    public IntervalConstraintView() {
+    public ShapeConstraintView() {
       InitializeComponent();
       int[] items = { 1, 2, 3 };
-      numberderivationInput.DataSource = items;
+      numberOfDerivationsComboBox.DataSource = items;
     }
 
@@ -62,8 +62,8 @@
       base.SetEnabledStateOfControls();
       variableInput.Enabled = Content != null && !Locked && !ReadOnly;
-      numberderivationInput.Enabled = Content != null && !Locked && !ReadOnly;
+      numberOfDerivationsComboBox.Enabled = Content != null && !Locked && !ReadOnly;
       lowerboundInput.Enabled = Content != null && !Locked && !ReadOnly;
       upperboundInput.Enabled = Content != null && !Locked && !ReadOnly;
-      weightInput.Enabled = Content != null && !Locked && !ReadOnly;
+      weightTextBox.Enabled = Content != null && !Locked && !ReadOnly;
     }
 
@@ -96,5 +96,5 @@
         lowerboundInput.Text = string.Empty;
         upperboundInput.Text = string.Empty;
-        weightInput.Text = string.Empty;
+        weightTextBox.Text = string.Empty;
         return;
       }
@@ -102,16 +102,16 @@
       lowerboundInput.Text = Content.Interval.LowerBound.ToString();
       upperboundInput.Text = Content.Interval.UpperBound.ToString();
-      weightInput.Text = Content.Weight.ToString();
+      weightTextBox.Text = Content.Weight.ToString();
 
       variableInput.Text = Content.Variable;
       if (!Content.IsDerivative) {
-        numberderivationInput.Enabled = false;
-        numberderivationInput.SelectedItem = null;
-        numberderivationInput.Text = "0";
+        numberOfDerivationsComboBox.Enabled = false;
+        numberOfDerivationsComboBox.SelectedItem = null;
+        numberOfDerivationsComboBox.Text = "0";
       } else {
-        numberderivationLabel.Visible = true;
-        numberderivationInput.Visible = true;
-        numberderivationInput.Enabled = true;
-        numberderivationInput.SelectedItem = Content.NumberOfDerivations;
+        numberOfDerivationLabel.Visible = true;
+        numberOfDerivationsComboBox.Visible = true;
+        numberOfDerivationsComboBox.Enabled = true;
+        numberOfDerivationsComboBox.SelectedItem = Content.NumberOfDerivations;
       }
 
@@ -172,20 +172,20 @@
 
     private void numberderivationInput_SelectedIndexChanged(object sender, EventArgs e) {
-      if (numberderivationInput.SelectedItem == null) {
+      if (numberOfDerivationsComboBox.SelectedItem == null) {
         Content.NumberOfDerivations = 0;
-        numberderivationInput.Enabled = false;
-        return;
-      }
-
-      if ((int)numberderivationInput.SelectedItem == 1)
+        numberOfDerivationsComboBox.Enabled = false;
+        return;
+      }
+
+      if ((int)numberOfDerivationsComboBox.SelectedItem == 1)
         Content.NumberOfDerivations = 1;
-      else if ((int)numberderivationInput.SelectedItem == 2)
+      else if ((int)numberOfDerivationsComboBox.SelectedItem == 2)
         Content.NumberOfDerivations = 2;
-      else if ((int)numberderivationInput.SelectedItem == 3)
+      else if ((int)numberOfDerivationsComboBox.SelectedItem == 3)
         Content.NumberOfDerivations = 3;
     }
 
     private void weightInput_TextChanged(object sender, EventArgs e) {
-      var value = ParseDoubleValue(weightInput.Text, weightInput, errorProvider);
+      var value = ParseDoubleValue(weightTextBox.Text, weightTextBox, errorProvider);
       if (!double.IsNaN(value)) Content.Weight = value;
     }