Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 17910)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 17911)
@@ -109,5 +109,4 @@
           Add(new Result(ModelBoundsResultName, "Results concerning the derivation of symbolic regression solution", value));
         }
-
       }
     }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalArithBoundsEstimator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalArithBoundsEstimator.cs	(revision 17910)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalArithBoundsEstimator.cs	(revision 17911)
@@ -232,5 +232,5 @@
             for (var i = 1; i < currentInstr.nArguments; i++) {
               var argumentInterval = Evaluate(instructions, ref instructionCounter, nodeIntervals, variableIntervals);
-              result = Interval.AnalyticalQuotient(result, argumentInterval);
+              result = Interval.AnalyticQuotient(result, argumentInterval);
             }
 
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalInterpreter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalInterpreter.cs	(revision 17910)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalInterpreter.cs	(revision 17911)
@@ -146,5 +146,5 @@
         throw new ArgumentNullException("No variablew ranges are present!", nameof(variableRanges));
 
-      //Check if all variables used in the tree are present in the dataset
+      // Check if all variables used in the tree are present in the dataset
       foreach (var variable in tree.IterateNodesPrefix().OfType<VariableTreeNode>().Select(n => n.VariableName)
                                    .Distinct())
@@ -191,5 +191,4 @@
             break;
           }
-        //Elementary arithmetic rules
         case OpCodes.Add: {
             result = Evaluate(instructions, ref instructionCounter, nodeIntervals, variableIntervals);
@@ -293,5 +292,5 @@
             for (var i = 1; i < currentInstr.nArguments; i++) {
               var argumentInterval = Evaluate(instructions, ref instructionCounter, nodeIntervals, variableIntervals);
-              result = Interval.AnalyticalQuotient(result, argumentInterval);
+              result = Interval.AnalyticQuotient(result, argumentInterval);
             }
 
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/DatasetExtensions.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/DatasetExtensions.cs	(revision 17910)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/DatasetExtensions.cs	(revision 17911)
@@ -96,4 +96,14 @@
     }
 
+    public static IntervalCollection GetIntervals(this IDataset dataset) {
+      IntervalCollection intervalCollection = new IntervalCollection();
+      foreach (var variable in dataset.DoubleVariables) { // intervals are only possible for double variables
+        var variableInterval = Interval.GetInterval(dataset.GetDoubleValues(variable));
+        intervalCollection.AddInterval(variable, variableInterval);
+      }
+
+      return intervalCollection;
+    }
+
     public static IEnumerable<KeyValuePair<string, IEnumerable<string>>> GetFactorVariableValues(
       this IDataset ds, IEnumerable<string> factorVariables, IEnumerable<int> rows) {
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17910)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17911)
@@ -271,5 +271,5 @@
     }
 
-    public static Interval AnalyticalQuotient(Interval a, Interval b) {
+    public static Interval AnalyticQuotient(Interval a, Interval b) {
       var dividend = a;
       var divisor = Add(Square(b), new Interval(1.0, 1.0));
@@ -306,7 +306,7 @@
     public static Interval CubicRoot(double a) { return CubicRoot(new Interval(a)); }
     public static Interval Absolute(double a) { return Absolute(new Interval(a)); }
-    public static Interval AnalyticQuotient(Interval a, double b) { return AnalyticalQuotient(a, new Interval(b)); }
-    public static Interval AnalyticQuotient(double a, Interval b) { return AnalyticalQuotient(new Interval(a), b); }
-    public static Interval AnalyticQuotient(double a, double b) { return AnalyticalQuotient(new Interval(a), new Interval(b)); }
+    public static Interval AnalyticQuotient(Interval a, double b) { return AnalyticQuotient(a, new Interval(b)); }
+    public static Interval AnalyticQuotient(double a, Interval b) { return AnalyticQuotient(new Interval(a), b); }
+    public static Interval AnalyticQuotient(double a, double b) { return AnalyticQuotient(new Interval(a), new Interval(b)); }
     #endregion
   }
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraintsParser.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraintsParser.cs	(revision 17910)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/ShapeConstraintsParser.cs	(revision 17911)
@@ -76,5 +76,5 @@
     private const string weightRegex = @"\s*(weight:\s*(?<weight>\S*))?";
     public static ShapeConstraint ParseFunctionRangeConstraint(string expr) {
-      if (!expr.StartsWith("f")) throw new ArgumentException($"Invalid function range constraint {expr} (e.g. f in [1..2])", nameof(expr));
+      if (!expr.StartsWith("f")) throw new ArgumentException($"Invalid function range constraint {expr} (e.g. f in [1..2])");
       var start = "f".Length;
       var end = expr.Length;
@@ -131,5 +131,5 @@
           return new ShapeConstraint(interval, weight);
       } else
-        throw new ArgumentException($"The inserted target constraint {expr} is not valid.", nameof(expr));
+        throw new ArgumentException($"The target constraint {expr} is not valid.");
     }
     public static ShapeConstraint ParseDerivationConstraint(string expr) {
@@ -161,7 +161,7 @@
         if (enumeratorNumDeriv != "" || denominatorNumDeriv != "") {
           if (enumeratorNumDeriv == "" || denominatorNumDeriv == "")
-            throw new ArgumentException($"Number of derivation has to be written on both sides in {expr}.", nameof(expr));
+            throw new ArgumentException($"Number of derivation has to be written on both sides in {expr}.");
           if (enumeratorNumDeriv != denominatorNumDeriv)
-            throw new ArgumentException($"Derivation number is not equal on both sides in {expr}.", nameof(expr));
+            throw new ArgumentException($"Derivation number is not equal on both sides in {expr}.");
         }
 
@@ -193,5 +193,5 @@
           return new ShapeConstraint(variable, numberOfDerivation, interval, weight);
       } else
-        throw new ArgumentException($"The inserted derivation constraint {expr} is not valid.", nameof(expr));
+        throw new ArgumentException($"The derivation constraint {expr} is not valid.");
     }
 
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17910)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17911)
@@ -99,16 +99,15 @@
     #endregion
 
-    public IConstrainedValueParameter<StringValue> TargetVariableParameter {
-      get { return (IConstrainedValueParameter<StringValue>)Parameters[TargetVariableParameterName]; }
-    }
-
+    #region parameter properties
+    public IConstrainedValueParameter<StringValue> TargetVariableParameter => (IConstrainedValueParameter<StringValue>)Parameters[TargetVariableParameterName];
+    public IFixedValueParameter<ShapeConstraints> ShapeConstraintsParameter => (IFixedValueParameter<ShapeConstraints>)Parameters[ShapeConstraintsParameterName];
     public IFixedValueParameter<IntervalCollection> VariableRangesParameter => (IFixedValueParameter<IntervalCollection>)Parameters[VariableRangesParameterName];
-
+    #endregion
+
+    #region properties
     public IntervalCollection VariableRanges {
       get => VariableRangesParameter.Value;
     }
 
-    public IFixedValueParameter<ShapeConstraints> ShapeConstraintsParameter =>
-      (IFixedValueParameter<ShapeConstraints>) Parameters[ShapeConstraintsParameterName];
 
     public ShapeConstraints ShapeConstraints => ShapeConstraintsParameter.Value;
@@ -126,14 +125,9 @@
       }
     }
-
-    public IEnumerable<double> TargetVariableValues {
-      get { return Dataset.GetDoubleValues(TargetVariable); }
-    }
-    public IEnumerable<double> TargetVariableTrainingValues {
-      get { return Dataset.GetDoubleValues(TargetVariable, TrainingIndices); }
-    }
-    public IEnumerable<double> TargetVariableTestValues {
-      get { return Dataset.GetDoubleValues(TargetVariable, TestIndices); }
-    }
+    public IEnumerable<double> TargetVariableValues => Dataset.GetDoubleValues(TargetVariable);
+    public IEnumerable<double> TargetVariableTrainingValues => Dataset.GetDoubleValues(TargetVariable, TrainingIndices);
+    public IEnumerable<double> TargetVariableTestValues => Dataset.GetDoubleValues(TargetVariable, TestIndices);
+    #endregion
+
 
 
@@ -143,8 +137,8 @@
     private void AfterDeserialization() {
       if (!Parameters.ContainsKey(VariableRangesParameterName)) {
-        var intervalCollection = CalculateDatasetIntervals(this.Dataset);
+        var intervalCollection = Dataset.GetIntervals();
         Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, intervalCollection));
       }
-      if(Parameters.ContainsKey("IntervalConstraints")) {
+      if (Parameters.ContainsKey("IntervalConstraints")) {
         var param = (IFixedValueParameter<ShapeConstraints>)Parameters["IntervalConstraints"];
         Parameters.Remove(param);
@@ -178,5 +172,5 @@
     }
 
-    public RegressionProblemData(IDataset dataset, IEnumerable<string> allowedInputVariables, string targetVariable, 
+    public RegressionProblemData(IDataset dataset, IEnumerable<string> allowedInputVariables, string targetVariable,
       IEnumerable<ITransformation> transformations = null,
       IntervalCollection variableRanges = null,
@@ -186,28 +180,19 @@
       Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>(variables), variables.Where(x => x.Value == targetVariable).First()));
       if (variableRanges == null) {
-        variableRanges = CalculateDatasetIntervals(this.Dataset);
+        variableRanges = Dataset.GetIntervals();
       }
       Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, variableRanges));
+
       if (shapeConstraints == null) {
         shapeConstraints = new ShapeConstraints();
-      } 
+      }
       Parameters.Add(new FixedValueParameter<ShapeConstraints>(ShapeConstraintsParameterName, shapeConstraints));
       RegisterParameterEvents();
     }
-
-    private static IntervalCollection CalculateDatasetIntervals(IDataset dataset) {
-      IntervalCollection intervalCollection = new IntervalCollection();
-      foreach (var variable in dataset.DoubleVariables) { // intervals are only possible for double variables
-        var variableInterval = Interval.GetInterval(dataset.GetDoubleValues(variable));
-        intervalCollection.AddInterval(variable, variableInterval);
-      }
-
-      return intervalCollection;
-    }
-
     private void RegisterParameterEvents() {
-      TargetVariableParameter.ValueChanged += new EventHandler(TargetVariableParameter_ValueChanged);
-    }
-    private void TargetVariableParameter_ValueChanged(object sender, EventArgs e) {
+      TargetVariableParameter.ValueChanged += new EventHandler(Parameter_ValueChanged);
+      // VariableRanges and ShapeConstraints are fixed parameters
+    }
+    private void Parameter_ValueChanged(object sender, EventArgs e) {
       OnChanged();
     }