Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ArrayJsonItemControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ArrayJsonItemControl.Designer.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ArrayJsonItemControl.Designer.cs	(revision 17924)
@@ -43,7 +43,7 @@
       this.tableLayoutPanel1.Name = "tableLayoutPanel1";
       this.tableLayoutPanel1.RowCount = 2;
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 41F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 47F));
       this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 41);
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 47);
       this.tableLayoutPanel1.TabIndex = 24;
       // 
@@ -55,5 +55,6 @@
       this.groupBox2.Margin = new System.Windows.Forms.Padding(0);
       this.groupBox2.Name = "groupBox2";
-      this.groupBox2.Size = new System.Drawing.Size(526, 41);
+      this.groupBox2.Padding = new System.Windows.Forms.Padding(6);
+      this.groupBox2.Size = new System.Drawing.Size(526, 47);
       this.groupBox2.TabIndex = 19;
       this.groupBox2.TabStop = false;
@@ -66,11 +67,11 @@
       this.tableLayoutPanel2.Controls.Add(this.checkBoxResizable, 0, 0);
       this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 16);
+      this.tableLayoutPanel2.Location = new System.Drawing.Point(6, 19);
       this.tableLayoutPanel2.Margin = new System.Windows.Forms.Padding(0);
       this.tableLayoutPanel2.Name = "tableLayoutPanel2";
       this.tableLayoutPanel2.RowCount = 1;
       this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
-      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
-      this.tableLayoutPanel2.Size = new System.Drawing.Size(520, 22);
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 22F));
+      this.tableLayoutPanel2.Size = new System.Drawing.Size(514, 22);
       this.tableLayoutPanel2.TabIndex = 22;
       // 
@@ -82,5 +83,5 @@
       this.checkBoxResizable.Margin = new System.Windows.Forms.Padding(0);
       this.checkBoxResizable.Name = "checkBoxResizable";
-      this.checkBoxResizable.Size = new System.Drawing.Size(520, 22);
+      this.checkBoxResizable.Size = new System.Drawing.Size(514, 22);
       this.checkBoxResizable.TabIndex = 4;
       this.checkBoxResizable.Text = "Resizable";
@@ -93,5 +94,5 @@
       this.Controls.Add(this.tableLayoutPanel1);
       this.Name = "ArrayJsonItemControl";
-      this.Size = new System.Drawing.Size(526, 41);
+      this.Size = new System.Drawing.Size(526, 47);
       this.tableLayoutPanel1.ResumeLayout(false);
       this.groupBox2.ResumeLayout(false);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/CompoundControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/CompoundControl.Designer.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/CompoundControl.Designer.cs	(revision 17924)
@@ -47,5 +47,4 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.tableLayoutPanel1);
-      this.Margin = new System.Windows.Forms.Padding(0);
       this.Name = "CompoundControl";
       this.Size = new System.Drawing.Size(526, 22);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ConcreteItemsRestrictor.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ConcreteItemsRestrictor.Designer.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ConcreteItemsRestrictor.Designer.cs	(revision 17924)
@@ -43,5 +43,5 @@
       this.tableOptions.RowCount = 1;
       this.tableOptions.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableOptions.Size = new System.Drawing.Size(494, 181);
+      this.tableOptions.Size = new System.Drawing.Size(491, 181);
       this.tableOptions.TabIndex = 13;
       // 
@@ -53,4 +53,5 @@
       this.groupBox1.Margin = new System.Windows.Forms.Padding(0);
       this.groupBox1.Name = "groupBox1";
+      this.groupBox1.Padding = new System.Windows.Forms.Padding(3, 3, 6, 3);
       this.groupBox1.Size = new System.Drawing.Size(500, 200);
       this.groupBox1.TabIndex = 0;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ConcreteItemsRestrictor.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ConcreteItemsRestrictor.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ConcreteItemsRestrictor.cs	(revision 17924)
@@ -40,4 +40,5 @@
       CheckBox checkBox = new CheckBox();
       checkBox.Checked = true;
+      checkBox.Margin = new Padding(0);
 
       checkBox.CheckStateChanged += (o, args) => {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBaseControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBaseControl.Designer.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBaseControl.Designer.cs	(revision 17924)
@@ -46,6 +46,6 @@
       this.textBoxName.Dock = System.Windows.Forms.DockStyle.Fill;
       this.errorProvider.SetIconAlignment(this.textBoxName, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.textBoxName.Location = new System.Drawing.Point(100, 2);
-      this.textBoxName.Margin = new System.Windows.Forms.Padding(0, 2, 0, 0);
+      this.textBoxName.Location = new System.Drawing.Point(100, 0);
+      this.textBoxName.Margin = new System.Windows.Forms.Padding(0);
       this.textBoxName.Name = "textBoxName";
       this.textBoxName.Size = new System.Drawing.Size(394, 20);
@@ -62,7 +62,9 @@
       this.tableLayoutPanel1.Margin = new System.Windows.Forms.Padding(0);
       this.tableLayoutPanel1.Name = "tableLayoutPanel1";
-      this.tableLayoutPanel1.RowCount = 2;
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 50F));
+      this.tableLayoutPanel1.RowCount = 3;
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 44F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 6F));
       this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
       this.tableLayoutPanel1.Size = new System.Drawing.Size(494, 594);
       this.tableLayoutPanel1.TabIndex = 16;
@@ -85,5 +87,5 @@
       this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
       this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
-      this.tableLayoutPanel5.Size = new System.Drawing.Size(494, 50);
+      this.tableLayoutPanel5.Size = new System.Drawing.Size(494, 44);
       this.tableLayoutPanel5.TabIndex = 17;
       // 
@@ -91,6 +93,6 @@
       // 
       this.textBoxDescription.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.textBoxDescription.Location = new System.Drawing.Point(100, 27);
-      this.textBoxDescription.Margin = new System.Windows.Forms.Padding(0, 2, 0, 0);
+      this.textBoxDescription.Location = new System.Drawing.Point(100, 23);
+      this.textBoxDescription.Margin = new System.Windows.Forms.Padding(0);
       this.textBoxDescription.Name = "textBoxDescription";
       this.textBoxDescription.Size = new System.Drawing.Size(394, 20);
@@ -104,5 +106,5 @@
       this.label1.Margin = new System.Windows.Forms.Padding(0);
       this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(100, 25);
+      this.label1.Size = new System.Drawing.Size(100, 23);
       this.label1.TabIndex = 9;
       this.label1.Text = "Name";
@@ -113,8 +115,8 @@
       this.labelDescription.AutoSize = true;
       this.labelDescription.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.labelDescription.Location = new System.Drawing.Point(0, 25);
+      this.labelDescription.Location = new System.Drawing.Point(0, 23);
       this.labelDescription.Margin = new System.Windows.Forms.Padding(0);
       this.labelDescription.Name = "labelDescription";
-      this.labelDescription.Size = new System.Drawing.Size(100, 25);
+      this.labelDescription.Size = new System.Drawing.Size(100, 24);
       this.labelDescription.TabIndex = 13;
       this.labelDescription.Text = "Description";
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBaseControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBaseControl.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBaseControl.cs	(revision 17924)
@@ -15,5 +15,5 @@
       if (control != null) {
         control.Margin = new Padding() { All = 0 };
-        tableLayoutPanel1.Controls.Add(control, 0, 1);
+        tableLayoutPanel1.Controls.Add(control, 0, 2);
         control.Dock = DockStyle.Fill;
       }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/MatrixJsonItemControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/MatrixJsonItemControl.Designer.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/MatrixJsonItemControl.Designer.cs	(revision 17924)
@@ -28,6 +28,6 @@
       this.groupBox2 = new System.Windows.Forms.GroupBox();
       this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
+      this.checkBoxRowsResizable = new System.Windows.Forms.CheckBox();
       this.checkBoxColumnsResizable = new System.Windows.Forms.CheckBox();
-      this.checkBoxRowsResizable = new System.Windows.Forms.CheckBox();
       this.tableLayoutPanel1.SuspendLayout();
       this.groupBox2.SuspendLayout();
@@ -46,5 +46,5 @@
       this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 63F));
       this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 63);
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 69);
       this.tableLayoutPanel1.TabIndex = 24;
       // 
@@ -56,4 +56,5 @@
       this.groupBox2.Margin = new System.Windows.Forms.Padding(0);
       this.groupBox2.Name = "groupBox2";
+      this.groupBox2.Padding = new System.Windows.Forms.Padding(6);
       this.groupBox2.Size = new System.Drawing.Size(526, 63);
       this.groupBox2.TabIndex = 19;
@@ -69,5 +70,5 @@
       this.tableLayoutPanel2.Controls.Add(this.checkBoxColumnsResizable, 0, 1);
       this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 16);
+      this.tableLayoutPanel2.Location = new System.Drawing.Point(6, 19);
       this.tableLayoutPanel2.Margin = new System.Windows.Forms.Padding(0);
       this.tableLayoutPanel2.Name = "tableLayoutPanel2";
@@ -75,18 +76,6 @@
       this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
       this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel2.Size = new System.Drawing.Size(520, 44);
+      this.tableLayoutPanel2.Size = new System.Drawing.Size(514, 38);
       this.tableLayoutPanel2.TabIndex = 22;
-      // 
-      // checkBoxColumnsResizable
-      // 
-      this.checkBoxColumnsResizable.AutoSize = true;
-      this.checkBoxColumnsResizable.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.checkBoxColumnsResizable.Location = new System.Drawing.Point(0, 22);
-      this.checkBoxColumnsResizable.Margin = new System.Windows.Forms.Padding(0);
-      this.checkBoxColumnsResizable.Name = "checkBoxColumnsResizable";
-      this.checkBoxColumnsResizable.Size = new System.Drawing.Size(520, 22);
-      this.checkBoxColumnsResizable.TabIndex = 7;
-      this.checkBoxColumnsResizable.Text = "Columns Resizable";
-      this.checkBoxColumnsResizable.UseVisualStyleBackColor = true;
       // 
       // checkBoxRowsResizable
@@ -97,8 +86,20 @@
       this.checkBoxRowsResizable.Margin = new System.Windows.Forms.Padding(0);
       this.checkBoxRowsResizable.Name = "checkBoxRowsResizable";
-      this.checkBoxRowsResizable.Size = new System.Drawing.Size(520, 22);
+      this.checkBoxRowsResizable.Size = new System.Drawing.Size(514, 19);
       this.checkBoxRowsResizable.TabIndex = 4;
       this.checkBoxRowsResizable.Text = "Rows Resizable";
       this.checkBoxRowsResizable.UseVisualStyleBackColor = true;
+      // 
+      // checkBoxColumnsResizable
+      // 
+      this.checkBoxColumnsResizable.AutoSize = true;
+      this.checkBoxColumnsResizable.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkBoxColumnsResizable.Location = new System.Drawing.Point(0, 19);
+      this.checkBoxColumnsResizable.Margin = new System.Windows.Forms.Padding(0);
+      this.checkBoxColumnsResizable.Name = "checkBoxColumnsResizable";
+      this.checkBoxColumnsResizable.Size = new System.Drawing.Size(514, 19);
+      this.checkBoxColumnsResizable.TabIndex = 7;
+      this.checkBoxColumnsResizable.Text = "Columns Resizable";
+      this.checkBoxColumnsResizable.UseVisualStyleBackColor = true;
       // 
       // MatrixJsonItemControl
@@ -108,5 +109,5 @@
       this.Controls.Add(this.tableLayoutPanel1);
       this.Name = "MatrixJsonItemControl";
-      this.Size = new System.Drawing.Size(526, 63);
+      this.Size = new System.Drawing.Size(526, 69);
       this.tableLayoutPanel1.ResumeLayout(false);
       this.groupBox2.ResumeLayout(false);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/NumericRangeControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/NumericRangeControl.Designer.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/NumericRangeControl.Designer.cs	(revision 17924)
@@ -46,5 +46,6 @@
       this.groupBox2.Margin = new System.Windows.Forms.Padding(0);
       this.groupBox2.Name = "groupBox2";
-      this.groupBox2.Size = new System.Drawing.Size(526, 63);
+      this.groupBox2.Padding = new System.Windows.Forms.Padding(6);
+      this.groupBox2.Size = new System.Drawing.Size(526, 69);
       this.groupBox2.TabIndex = 19;
       this.groupBox2.TabStop = false;
@@ -54,5 +55,5 @@
       // 
       this.tableLayoutPanel2.ColumnCount = 2;
-      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 100F));
+      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 93F));
       this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
       this.tableLayoutPanel2.Controls.Add(this.textBoxTo, 1, 1);
@@ -61,5 +62,5 @@
       this.tableLayoutPanel2.Controls.Add(this.checkBoxTo, 0, 1);
       this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 16);
+      this.tableLayoutPanel2.Location = new System.Drawing.Point(6, 19);
       this.tableLayoutPanel2.Margin = new System.Windows.Forms.Padding(0);
       this.tableLayoutPanel2.Name = "tableLayoutPanel2";
@@ -67,6 +68,5 @@
       this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
       this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
-      this.tableLayoutPanel2.Size = new System.Drawing.Size(520, 44);
+      this.tableLayoutPanel2.Size = new System.Drawing.Size(514, 44);
       this.tableLayoutPanel2.TabIndex = 22;
       // 
@@ -75,9 +75,9 @@
       this.textBoxTo.Dock = System.Windows.Forms.DockStyle.Fill;
       this.errorProvider.SetIconAlignment(this.textBoxTo, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.textBoxTo.Location = new System.Drawing.Point(100, 22);
+      this.textBoxTo.Location = new System.Drawing.Point(93, 22);
       this.textBoxTo.Margin = new System.Windows.Forms.Padding(0);
       this.textBoxTo.Name = "textBoxTo";
       this.textBoxTo.ReadOnly = true;
-      this.textBoxTo.Size = new System.Drawing.Size(420, 20);
+      this.textBoxTo.Size = new System.Drawing.Size(421, 20);
       this.textBoxTo.TabIndex = 6;
       this.textBoxTo.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxTo_Validating);
@@ -87,9 +87,9 @@
       this.textBoxFrom.Dock = System.Windows.Forms.DockStyle.Fill;
       this.errorProvider.SetIconAlignment(this.textBoxFrom, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.textBoxFrom.Location = new System.Drawing.Point(100, 0);
+      this.textBoxFrom.Location = new System.Drawing.Point(93, 0);
       this.textBoxFrom.Margin = new System.Windows.Forms.Padding(0);
       this.textBoxFrom.Name = "textBoxFrom";
       this.textBoxFrom.ReadOnly = true;
-      this.textBoxFrom.Size = new System.Drawing.Size(420, 20);
+      this.textBoxFrom.Size = new System.Drawing.Size(421, 20);
       this.textBoxFrom.TabIndex = 2;
       this.textBoxFrom.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxFrom_Validating);
@@ -102,5 +102,5 @@
       this.checkBoxFrom.Margin = new System.Windows.Forms.Padding(0);
       this.checkBoxFrom.Name = "checkBoxFrom";
-      this.checkBoxFrom.Size = new System.Drawing.Size(100, 22);
+      this.checkBoxFrom.Size = new System.Drawing.Size(93, 22);
       this.checkBoxFrom.TabIndex = 4;
       this.checkBoxFrom.Text = "From:";
@@ -114,5 +114,5 @@
       this.checkBoxTo.Margin = new System.Windows.Forms.Padding(0);
       this.checkBoxTo.Name = "checkBoxTo";
-      this.checkBoxTo.Size = new System.Drawing.Size(100, 22);
+      this.checkBoxTo.Size = new System.Drawing.Size(93, 22);
       this.checkBoxTo.TabIndex = 7;
       this.checkBoxTo.Text = "To:";
@@ -133,7 +133,7 @@
       this.tableLayoutPanel1.Name = "tableLayoutPanel1";
       this.tableLayoutPanel1.RowCount = 2;
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 63F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 69F));
       this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 63);
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 69);
       this.tableLayoutPanel1.TabIndex = 23;
       // 
@@ -144,5 +144,5 @@
       this.Controls.Add(this.tableLayoutPanel1);
       this.Name = "NumericRangeControl";
-      this.Size = new System.Drawing.Size(526, 63);
+      this.Size = new System.Drawing.Size(526, 69);
       this.groupBox2.ResumeLayout(false);
       this.tableLayoutPanel2.ResumeLayout(false);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultJsonItemControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultJsonItemControl.Designer.cs	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultJsonItemControl.Designer.cs	(revision 17924)
@@ -39,5 +39,6 @@
       this.groupBox1.Margin = new System.Windows.Forms.Padding(0);
       this.groupBox1.Name = "groupBox1";
-      this.groupBox1.Size = new System.Drawing.Size(526, 41);
+      this.groupBox1.Padding = new System.Windows.Forms.Padding(6);
+      this.groupBox1.Size = new System.Drawing.Size(526, 47);
       this.groupBox1.TabIndex = 0;
       this.groupBox1.TabStop = false;
@@ -49,7 +50,7 @@
       this.comboBoxFormatter.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.comboBoxFormatter.FormattingEnabled = true;
-      this.comboBoxFormatter.Location = new System.Drawing.Point(3, 16);
+      this.comboBoxFormatter.Location = new System.Drawing.Point(6, 19);
       this.comboBoxFormatter.Name = "comboBoxFormatter";
-      this.comboBoxFormatter.Size = new System.Drawing.Size(520, 21);
+      this.comboBoxFormatter.Size = new System.Drawing.Size(514, 21);
       this.comboBoxFormatter.TabIndex = 0;
       // 
@@ -63,7 +64,7 @@
       this.tableLayoutPanel1.Name = "tableLayoutPanel1";
       this.tableLayoutPanel1.RowCount = 2;
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 41F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 47F));
       this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 41);
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 47);
       this.tableLayoutPanel1.TabIndex = 1;
       // 
@@ -74,5 +75,5 @@
       this.Controls.Add(this.tableLayoutPanel1);
       this.Name = "ResultJsonItemControl";
-      this.Size = new System.Drawing.Size(526, 41);
+      this.Size = new System.Drawing.Size(526, 47);
       this.groupBox1.ResumeLayout(false);
       this.tableLayoutPanel1.ResumeLayout(false);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/HeuristicLab.JsonInterface.csproj
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/HeuristicLab.JsonInterface.csproj	(revision 17923)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/HeuristicLab.JsonInterface.csproj	(revision 17924)
@@ -102,8 +102,8 @@
     <Compile Include="JsonItems\ValueJsonItem.cs" />
     <Compile Include="JsonItems\ValueLookupJsonItem.cs" />
-    <Compile Include="ResultFormatter\MatlabResultFormatter.cs" />
-    <Compile Include="ResultFormatter\ResultFormatter.cs" />
-    <Compile Include="ResultFormatter\StringResultFormatter.cs" />
-    <Compile Include="ResultFormatter\SymbolicRegressionSolutionFormatterBase.cs" />
+    <Compile Include="ResultFormatters\MatlabResultFormatter.cs" />
+    <Compile Include="ResultFormatters\ResultFormatter.cs" />
+    <Compile Include="ResultFormatters\StringResultFormatter.cs" />
+    <Compile Include="ResultFormatters\SymbolicRegressionSolutionFormatterBase.cs" />
     <Compile Include="SingleLineArrayJsonWriter.cs" />
     <Compile Include="JsonTemplateGenerator.cs" />
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/MatlabResultFormatter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/MatlabResultFormatter.cs	(revision 17924)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/MatlabResultFormatter.cs	(revision 17924)
@@ -0,0 +1,9 @@
+﻿using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+
+namespace HeuristicLab.JsonInterface {
+  public class MatlabResultFormatter : SymbolicRegressionSolutionFormatterBase {
+    protected override ISymbolicExpressionTreeStringFormatter SymbolicExpressionTreeStringFormatter 
+      => new SymbolicDataAnalysisExpressionMATLABFormatter();
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/ResultFormatter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/ResultFormatter.cs	(revision 17924)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/ResultFormatter.cs	(revision 17924)
@@ -0,0 +1,31 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.JsonInterface {
+
+  /// <summary>
+  /// Base Class for ResultFormatter
+  /// </summary>
+  public abstract class ResultFormatter : IResultFormatter {
+    public abstract int Priority { get; }
+    public abstract bool CanFormatType(Type t);
+    public abstract string Format(object o);
+
+    /// <summary>
+    /// static property to get all existing result formatters
+    /// </summary>
+    public static IEnumerable<IResultFormatter> All { get; } =
+      PluginInfrastructure.ApplicationManager.Manager.GetInstances<IResultFormatter>();
+
+    /// <summary>
+    /// static method to get all existing result formatters for a specific type
+    /// </summary>
+    /// <param name="t">target type</param>
+    /// <returns>collection of found result formatters or null if none was found</returns>
+    public static IEnumerable<IResultFormatter> ForType(Type t) =>
+      All?.Where(x => x.CanFormatType(t)).OrderBy(x => x.Priority);
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/StringResultFormatter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/StringResultFormatter.cs	(revision 17924)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/StringResultFormatter.cs	(revision 17924)
@@ -0,0 +1,15 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.JsonInterface {
+  public class StringResultFormatter : ResultFormatter {
+    public override int Priority => 1;
+
+    public override bool CanFormatType(Type t) => true;
+
+    public override string Format(object o) => o.ToString();
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/SymbolicRegressionSolutionFormatterBase.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/SymbolicRegressionSolutionFormatterBase.cs	(revision 17924)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultFormatters/SymbolicRegressionSolutionFormatterBase.cs	(revision 17924)
@@ -0,0 +1,19 @@
+﻿using System;
+using System.Linq;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+
+namespace HeuristicLab.JsonInterface {
+  public abstract class SymbolicRegressionSolutionFormatterBase : ResultFormatter {
+    public override int Priority => 5;
+
+    public override bool CanFormatType(Type t) {
+      var interfaces = t.GetInterfaces();
+      return t.GetInterfaces().Any(x => x == typeof(ISymbolicRegressionSolution));
+    }
+
+    protected abstract ISymbolicExpressionTreeStringFormatter SymbolicExpressionTreeStringFormatter { get; }
+
+    public override string Format(object o) => SymbolicExpressionTreeStringFormatter.Format((ISymbolicExpressionTree)((ISymbolicRegressionSolution)o).Model.SymbolicExpressionTree);
+  }
+}