Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs	(revision 17922)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs	(revision 17929)
@@ -58,5 +58,5 @@
     }
 
-    private string GenerateHeader(ISymbolicExpressionTree symbolicExpressionTree) {
+    private static string GenerateHeader(ISymbolicExpressionTree symbolicExpressionTree) {
       StringBuilder strBuilder = new StringBuilder();
 
@@ -102,5 +102,5 @@
     }
 
-    private string GenerateNecessaryImports(int mathLibCounter, int statisticLibCounter) {
+    private static string GenerateNecessaryImports(int mathLibCounter, int statisticLibCounter) {
       StringBuilder strBuilder = new StringBuilder();
       if (mathLibCounter > 0 || statisticLibCounter > 0) {
@@ -115,5 +115,5 @@
     }
 
-    private string GenerateIfThenElseSource(int evaluateIfCounter) {
+    private static string GenerateIfThenElseSource(int evaluateIfCounter) {
       StringBuilder strBuilder = new StringBuilder();
       if (evaluateIfCounter > 0) {
@@ -128,5 +128,5 @@
     }
 
-    private string GenerateModelEvaluationFunction(ISet<string> variables) {
+    private static string GenerateModelEvaluationFunction(ISet<string> variables) {
       StringBuilder strBuilder = new StringBuilder();
       strBuilder.Append("def evaluate(");
@@ -142,5 +142,5 @@
     }
 
-    private void FormatRecursively(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+    private static void FormatRecursively(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       ISymbol symbol = node.Symbol;
       if (symbol is ProgramRootSymbol)
@@ -208,7 +208,7 @@
     }
 
-    private string VariableName2Identifier(string variableName) => variableName.Replace(" ", "_");
-
-    private void FormatNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder, string prefixSymbol = "", string openingSymbol = "(", string closingSymbol = ")", string infixSymbol = ",") {
+    private static string VariableName2Identifier(string variableName) => variableName.Replace(" ", "_");
+
+    private static void FormatNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder, string prefixSymbol = "", string openingSymbol = "(", string closingSymbol = ")", string infixSymbol = ",") {
       strBuilder.Append($"{prefixSymbol}{openingSymbol}");
       foreach (var child in node.Subtrees) {
@@ -220,5 +220,5 @@
     }
 
-    private void FormatVariableTreeNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+    private static void FormatVariableTreeNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       var varNode = node as VariableTreeNode;
       var formattedVariable = VariableName2Identifier(varNode.VariableName);
@@ -227,10 +227,10 @@
     }
 
-    private void FormatConstantTreeNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+    private static void FormatConstantTreeNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       var constNode = node as ConstantTreeNode;
       strBuilder.Append(constNode.Value.ToString("g17", CultureInfo.InvariantCulture));
     }
 
-    private void FormatPower(ISymbolicExpressionTreeNode node, StringBuilder strBuilder, string exponent) {
+    private static void FormatPower(ISymbolicExpressionTreeNode node, StringBuilder strBuilder, string exponent) {
       strBuilder.Append("math.pow(");
       FormatRecursively(node.GetSubtree(0), strBuilder);
@@ -238,5 +238,5 @@
     }
 
-    private void FormatRoot(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+    private static void FormatRoot(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       strBuilder.Append("math.pow(");
       FormatRecursively(node.GetSubtree(0), strBuilder);
@@ -246,5 +246,5 @@
     }
 
-    private void FormatSubtraction(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+    private static void FormatSubtraction(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       if (node.SubtreeCount == 1) {
         strBuilder.Append("-");
@@ -256,5 +256,5 @@
     }
 
-    private void FormatDivision(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+    private static void FormatDivision(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       strBuilder.Append("(");
       if (node.SubtreeCount == 1) {
@@ -273,5 +273,5 @@
     }
 
-    private void FormatAnalyticQuotient(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+    private static void FormatAnalyticQuotient(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       strBuilder.Append("(");
       FormatRecursively(node.GetSubtree(0), strBuilder);